#pragma once

#include "ActorInterface.h"
#include "WASCommand.h"
#include "WASActor.h"

class CWASSearchCallHistory : public CWASCommand
{
public:
	CWASSearchCallHistory(CWASActor *pActor);
	~CWASSearchCallHistory(void);

	void ExecuteAsync(void);

	void SetParameter(NTCallType eCallType, LPCWSTR strSearchWord, LPCWSTR strLangCode)
	{
		m_eCallType = eCallType;
		m_strSearchWord = strSearchWord;
		m_strLangCode = strLangCode;
	}

private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:
	NTCallType m_eCallType;
	WSTRING m_strLangCode;
	WSTRING m_strSearchWord;

	std::vector<NE_CALL_DATA> m_listCallHistory;

};
